#!/bin/sh
#
-# This is the git merge script, called with
+# Copyright (c) Linus Torvalds, 2005
+#
+# This is the git per-file merge script, called with
#
# $1 - original file SHA1 (or empty)
# $2 - file in branch1 SHA1 (or empty)
#
# Handle some trivial cases.. The _really_ trivial cases have
# been handled already by git-read-tree, but that one doesn't
-# do any merges that migth change the tree layout.
+# do any merges that might change the tree layout.
case "${1:-.}${2:-.}${3:-.}" in
#
-# Deleted in both.
-#
-"$1..")
- echo "ERROR: $4 is removed in both branches."
- echo "ERROR: This is a potential rename conflict."
- exit 1;;
-#
-# Deleted in one and unchanged in the other.
+# Deleted in both or deleted in one and unchanged in the other
#
"$1.." | "$1.$1" | "$1$1.")
- echo "Removing $4"
- exec git-update-cache --force-remove "$4" ;;
+ if [ "$2" ]; then
+ echo "Removing $4"
+ fi
+ if test -f "$4"; then
+ rm -f -- "$4"
+ fi &&
+ exec git-update-cache --remove -- "$4"
+ ;;
+
#
# Added in one.
#
".$2." | "..$3" )
- case "$6$7" in *7??) mode=+x;; *) mode=-x;; esac
- echo "Adding $4 with perm $mode."
- exec git-update-cache --add --cacheinfo "$6$7" "$2$3" "$4" ;;
+ echo "Adding $4"
+ git-update-cache --add --cacheinfo "$6$7" "$2$3" "$4" &&
+ exec git-checkout-cache -u -f -- "$4"
+ ;;
+
#
# Added in both (check for same permissions).
#
echo "ERROR: but permissions conflict $6->$7."
exit 1
fi
- case "$6" in *7??) mode=+x;; *) mode=-x;; esac
- echo "Adding $4 with perm $mode"
- exec git-update-cache --add --cacheinfo "$6" "$2" "$4" ;;
+ echo "Adding $4"
+ git-update-cache --add --cacheinfo "$6" "$2" "$4" &&
+ exec git-checkout-cache -u -f -- "$4"
+ ;;
+
#
# Modified in both, but differently.
#
"$1$2$3")
echo "Auto-merging $4."
- orig=$(git-unpack-file $1)
- src1=$(git-unpack-file $2)
- src2=$(git-unpack-file $3)
- merge "$src2" "$orig" "$src1"
+ orig=`git-unpack-file $1`
+ src2=`git-unpack-file $3`
+
+ # We reset the index to the first branch, making
+ # git-diff-file useful
+ git-update-cache --add --cacheinfo "$6" "$2" "$4"
+ git-checkout-cache -u -f -- "$4" &&
+ merge "$4" "$orig" "$src2"
ret=$?
+ rm -f -- "$orig" "$src2"
+
if [ "$6" != "$7" ]; then
- echo "ERROR: Permissions $5->$6->$7 don't match."
+ echo "ERROR: Permissions conflict: $5->$6,$7."
+ ret=1
fi
+
if [ $ret -ne 0 ]; then
- echo "ERROR: Leaving conflict merge in $src2."
+ echo "ERROR: Merge conflict in $4."
exit 1
fi
- sha1=$(git-write-blob "$src2") || {
- echo "ERROR: Leaving conflict merge in $src2."
- }
- exec git-update-cache --add --cacheinfo "$6" $sha1 "$4" ;;
+ exec git-update-cache -- "$4"
+ ;;
+
*)
- echo "ERROR: Not handling case $4: $1 -> $2 -> $3" ;;
+ echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
+ ;;
esac
exit 1